program clock_drift
! clock_drift.x < infile.H > outfile.H [drift_header='CLOCK_DRIFT_FRACTION']
  use sep

  implicit none

  interface
     subroutine CWPshfs8r(dx,nxin,fxin,yin,yinl,yinr,nxout,fxout,yout) &
        BIND(C,name="shfs8r")
        use iso_c_binding, only: c_int, c_float
        REAL(C_FLOAT), VALUE :: dx
        INTEGER(C_INT), VALUE :: nxin
        REAL(C_FLOAT), VALUE :: fxin
        REAL(C_FLOAT), DIMENSION(nxin) :: yin(:)
        REAL(C_FLOAT), VALUE :: yinl
        REAL(C_FLOAT), VALUE :: yinr
        INTEGER(C_INT), VALUE :: nxout
        REAL(C_FLOAT), VALUE :: fxout
        REAL(C_FLOAT), DIMENSION(nxout) :: yout(:)
     end subroutine CWPshfs8r
  end interface

  integer			:: n1,  i1, n2, i2
  real				:: o1, d1
  real, allocatable 		:: in(:), out(:)
  real				:: clock
  real    			:: ll, wt
  integer 			:: ill,il
  real				:: t_old, t_new, t_drift
  character (len=33)            :: drift_header_name

  integer, external		:: getch

  call sep_init(SOURCE)
  call from_history ('n1',n1)
  call from_history ('d1',d1)
  call from_history ('o1',o1)
  call from_history ('n2',n2)
  if(0 .EQ. getch('drift_header','s',drift_header_name)) then
      drift_header_name = 'CLOCK_DRIFT_FRACTION'//CHAR(0)
  endif
  allocate(in(n1),out(n1))

  out=0.0
  
  do i2=1,n2
    call sep_read(in)
    call sep_get_val_by_name('in',i2,drift_header_name,1,clock)
!   Already pulled traces upwards by integral number of samples
!   Now figure out the fractional drift time not corrected
    t_drift=clock/1000000.0
    call CWPshfs8r(d1,n1,o1,in,0.0,0.0,n1,o1+t_drift,out)
    call sep_write(out)
  end do

  deallocate(in, out)
  call sep_close()
end program

